package xyz.veronie.bgg.result;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;


public class ThingMetaData {
	private int id;
	private String name;
	private String imgURL;
	private String thumbURL;
	private String comment;
	private Integer numPlays;

	private static String[] titles = { "Id", "Name" }; //, "Image", "Thumb", "comment", "# plays"};
	
	private PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(this);
	
	public ThingMetaData(int id, String name, 
			String imgURL, String thumURL,
			String comment, Integer numPlays) {
		this.setId(id);
		this.setName(name);
		this.setImgURL(imgURL);
		this.setThumbURL(thumURL);
		this.setComment(comment);
		this.setNumPlays(numPlays);
	}
	
	public static String[] getTitles() {
		return titles;
	}
	
	public void addPropertyChangeListener(String propertyName,
            PropertyChangeListener listener) {
        propertyChangeSupport.addPropertyChangeListener(propertyName, listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        propertyChangeSupport.removePropertyChangeListener(listener);
    }
    
    /// get field at idx, order of titles
    public String getField(int idx) {
    	if(idx >= titles.length) {
    		
    	}
    	
    	String returnStr;

    	switch(idx) {
    	case 0:
    		returnStr = String.valueOf(this.id);
    		break;
    	case 1:
    		returnStr = this.name;
    		break;
//    	case 2:
//    		returnStr = this.imgURL;
//    		break;
//    	case 3:
//    		returnStr = this.thumbURL;
//    		break;
//    	case 4:
//    		returnStr = this.comment;
//    		break;
//    	case 5:
//    		if (this.numPlays == null) {
//    			returnStr = "";
//    		} else {
//    			returnStr = String.valueOf(this.numPlays);
//    		}
//    		break;
    	default:
    		throw new ArrayIndexOutOfBoundsException(
    				"idx " + String.valueOf(idx) + " must be in [0," + (titles.length-1) + "]");
    	}

    	return returnStr;
    }
    

	public int getId() {
		return id;
	}

	public void setId(int id) {
		propertyChangeSupport.firePropertyChange("id", this.id,
			this.id = id);
	}

    
	public String getName() {
		return name;
	}

	public void setName(String name) {
		propertyChangeSupport.firePropertyChange("name", this.name,
			this.name = name);
	}
	
	public String getImgURL() {
		return imgURL;
	}

	public void setImgURL(String imgURL) {
		propertyChangeSupport.firePropertyChange("img", this.imgURL,
			this.imgURL = imgURL);
	}

	public String getThumbURL() {
		return thumbURL;
	}
	
	public void setThumbURL(String thumbURL) {
		propertyChangeSupport.firePropertyChange("thumb", this.thumbURL,
			this.thumbURL = thumbURL);
	}

	public int getNumPlays() {
		return numPlays;
	}

	public void setNumPlays(Integer numPlays) {
		this.numPlays = numPlays;
	}


	public String getComment() {
		return comment;
	}

	public void setComment(String comment) {
		propertyChangeSupport.firePropertyChange("comment", this.comment,
			this.comment = comment);
	}

	@Override
    public String toString() {
        return String.valueOf(id);
    }

}

